using Indotalent.ConfigBackEnd.Interfaces;
using Indotalent.ConfigFrontEnd.Common;
using Indotalent.Features.Root.Home.Cqrs;
using Indotalent.Infrastructure.Authentication.Identity;
using Indotalent.Shared.Models;
using Microsoft.AspNetCore.Components;
using MudBlazor;
using RestSharp;

namespace Indotalent.Features.Root.Home;

public class HomeService : BaseService
{
    private readonly RestClient _client;

    public HomeService(IHttpClientFactory clientFactory, NavigationManager nav, ISnackbar snackbar, ICurrentUserService currentUserService, TokenProvider tokenProvider)
            : base(clientFactory, nav, snackbar, currentUserService, tokenProvider)
    {
        _client = new RestClient(nav.BaseUri);
    }

    public async Task<ApiResponse<DashboardScmResponse>?> GetScmDashboardStatsAsync()
    {
        var request = new RestRequest("api/dashboard/scm-stats", Method.Get);
        request.AddHeader("Accept", "application/json");
        return await ExecuteWithResponseAsync<DashboardScmResponse>(_client, request);
    }
}